diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/block-ack-manager.cc ns-3.44/src/wifi/model/block-ack-manager.cc
--- ns-3.43/src/wifi/model/block-ack-manager.cc	2024-10-09 16:41:10.116656800 -0700
+++ ns-3.44/src/wifi/model/block-ack-manager.cc	2025-03-09 16:55:49.783372600 -0700
@@ -62,27 +62,95 @@
     m_queue = nullptr;
 }
 
+BlockAckManager::OriginatorAgreementsI
+BlockAckManager::GetOriginatorBaAgreement(const Mac48Address& recipient,
+                                          uint8_t tid,
+                                          std::optional<Mac48Address> gcrGroupAddr)
+{
+    auto [first, last] = m_originatorAgreements.equal_range({recipient, tid});
+    for (auto it = first; it != last; ++it)
+    {
+        [[maybe_unused]] const auto& [baAgreement, packetQueue] = it->second;
+        if (baAgreement.GetGcrGroupAddress() == gcrGroupAddr)
+        {
+            return it;
+        }
+    }
+    return m_originatorAgreements.end();
+}
+
+BlockAckManager::OriginatorAgreementsCI
+BlockAckManager::GetOriginatorBaAgreement(const Mac48Address& recipient,
+                                          uint8_t tid,
+                                          std::optional<Mac48Address> gcrGroupAddr) const
+{
+    const auto [first, last] = m_originatorAgreements.equal_range({recipient, tid});
+    for (auto it = first; it != last; ++it)
+    {
+        [[maybe_unused]] const auto& [baAgreement, packetQueue] = it->second;
+        if (baAgreement.GetGcrGroupAddress() == gcrGroupAddr)
+        {
+            return it;
+        }
+    }
+    return m_originatorAgreements.cend();
+}
+
+BlockAckManager::RecipientAgreementsI
+BlockAckManager::GetRecipientBaAgreement(const Mac48Address& originator,
+                                         uint8_t tid,
+                                         std::optional<Mac48Address> gcrGroupAddr)
+{
+    auto [first, last] = m_recipientAgreements.equal_range({originator, tid});
+    for (auto it = first; it != last; ++it)
+    {
+        if (it->second.GetGcrGroupAddress() == gcrGroupAddr)
+        {
+            return it;
+        }
+    }
+    return m_recipientAgreements.end();
+}
+
+BlockAckManager::RecipientAgreementsCI
+BlockAckManager::GetRecipientBaAgreement(const Mac48Address& originator,
+                                         uint8_t tid,
+                                         std::optional<Mac48Address> gcrGroupAddr) const
+{
+    const auto [first, last] = m_recipientAgreements.equal_range({originator, tid});
+    for (auto it = first; it != last; ++it)
+    {
+        if (it->second.GetGcrGroupAddress() == gcrGroupAddr)
+        {
+            return it;
+        }
+    }
+    return m_recipientAgreements.cend();
+}
+
 BlockAckManager::OriginatorAgreementOptConstRef
-BlockAckManager::GetAgreementAsOriginator(const Mac48Address& recipient, uint8_t tid) const
+BlockAckManager::GetAgreementAsOriginator(const Mac48Address& recipient,
+                                          uint8_t tid,
+                                          std::optional<Mac48Address> gcrGroupAddr) const
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    if (auto it = m_originatorAgreements.find({recipient, tid}); it != m_originatorAgreements.end())
+    if (const auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
+        it != m_originatorAgreements.cend())
     {
         return std::cref(it->second.first);
     }
-
     return std::nullopt;
 }
 
 BlockAckManager::RecipientAgreementOptConstRef
-BlockAckManager::GetAgreementAsRecipient(const Mac48Address& originator, uint8_t tid) const
+BlockAckManager::GetAgreementAsRecipient(const Mac48Address& originator,
+                                         uint8_t tid,
+                                         std::optional<Mac48Address> gcrGroupAddr) const
 {
-    NS_LOG_FUNCTION(this << originator << +tid);
-    if (auto it = m_recipientAgreements.find({originator, tid}); it != m_recipientAgreements.end())
+    if (const auto it = GetRecipientBaAgreement(originator, tid, gcrGroupAddr);
+        it != m_recipientAgreements.end())
     {
         return std::cref(it->second);
     }
-
     return std::nullopt;
 }
 
@@ -109,27 +177,51 @@
     {
         agreement.SetDelayedBlockAck();
     }
+    if (const auto gcrGroupAddr = reqHdr.GetGcrGroupAddress())
+    {
+        agreement.SetGcrGroupAddress(*gcrGroupAddr);
+    }
     agreement.SetState(OriginatorBlockAckAgreement::PENDING);
+
     m_originatorAgreementState(Simulator::Now(),
                                recipient,
                                tid,
                                OriginatorBlockAckAgreement::PENDING);
-    if (auto existingAgreement = GetAgreementAsOriginator(recipient, tid))
+
+    if (auto it = GetOriginatorBaAgreement(recipient, tid, reqHdr.GetGcrGroupAddress());
+        it != m_originatorAgreements.end())
     {
-        NS_ASSERT_MSG(existingAgreement->get().IsReset(),
-                      "Existing agreement must be in RESET state");
+        NS_ASSERT_MSG(it->second.first.IsReset(), "Existing agreement must be in RESET state");
+        it->second = std::make_pair(std::move(agreement), PacketQueue{});
     }
-    m_originatorAgreements.insert_or_assign({recipient, tid},
-                                            std::make_pair(std::move(agreement), PacketQueue{}));
-    m_blockPackets(recipient, tid);
+    else
+    {
+        m_originatorAgreements.emplace(std::make_pair(recipient, tid),
+                                       std::make_pair(std::move(agreement), PacketQueue{}));
+    }
+
+    const auto [first, last] = m_originatorAgreements.equal_range({recipient, tid});
+    NS_ASSERT_MSG(std::count_if(first,
+                                last,
+                                [&reqHdr](const auto& elem) {
+                                    return elem.second.first.GetGcrGroupAddress() ==
+                                           reqHdr.GetGcrGroupAddress();
+                                }) == 1,
+                  "There exists more than one "
+                      << (reqHdr.GetGcrGroupAddress().has_value() ? "GCR " : " ")
+                      << "Block Ack agreement for recipient " << recipient << " and tid " << +tid);
+
+    m_blockPackets(reqHdr.GetGcrGroupAddress().value_or(recipient), tid);
 }
 
 void
-BlockAckManager::DestroyOriginatorAgreement(const Mac48Address& recipient, uint8_t tid)
+BlockAckManager::DestroyOriginatorAgreement(const Mac48Address& recipient,
+                                            uint8_t tid,
+                                            std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    auto it = m_originatorAgreements.find({recipient, tid});
-    if (it != m_originatorAgreements.end())
+    NS_LOG_FUNCTION(this << recipient << tid << gcrGroupAddr.has_value());
+    if (auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
+        it != m_originatorAgreements.end())
     {
         m_originatorAgreements.erase(it);
     }
@@ -141,9 +233,9 @@
                                            uint16_t startingSeq)
 {
     NS_LOG_FUNCTION(this << respHdr << recipient << startingSeq);
-    uint8_t tid = respHdr.GetTid();
-    auto it = m_originatorAgreements.find({recipient, tid});
-    if (it != m_originatorAgreements.end())
+    const auto tid = respHdr.GetTid();
+    if (auto it = GetOriginatorBaAgreement(recipient, tid, respHdr.GetGcrGroupAddress());
+        it != m_originatorAgreements.end())
     {
         OriginatorBlockAckAgreement& agreement = it->second.first;
         agreement.SetBufferSize(respHdr.GetBufferSize());
@@ -159,6 +251,11 @@
         {
             agreement.SetDelayedBlockAck();
         }
+        if (const auto gcrGroupAddr = respHdr.GetGcrGroupAddress())
+        {
+            agreement.SetGcrGroupAddress(*gcrGroupAddr);
+            m_gcrBlockAcks.emplace(*gcrGroupAddr, GcrBlockAcks{});
+        }
         if (!it->second.first.IsEstablished())
         {
             m_originatorAgreementState(Simulator::Now(),
@@ -174,10 +271,30 @@
                                                               &BlockAckManager::InactivityTimeout,
                                                               this,
                                                               recipient,
-                                                              tid);
+                                                              tid,
+                                                              respHdr.GetGcrGroupAddress());
+        }
+    }
+    if (!respHdr.GetGcrGroupAddress().has_value())
+    {
+        m_unblockPackets(recipient, tid);
+    }
+    else
+    {
+        for (const auto& agreement : m_originatorAgreements)
+        {
+            if (agreement.second.first.GetGcrGroupAddress() != respHdr.GetGcrGroupAddress())
+            {
+                continue;
+            }
+            if (!agreement.second.first.IsEstablished())
+            {
+                return;
+            }
         }
+        // established with all members so we can unblock
+        m_unblockPackets(respHdr.GetGcrGroupAddress().value(), tid);
     }
-    m_unblockPackets(recipient, tid);
 }
 
 void
@@ -206,21 +323,45 @@
     {
         agreement.SetDelayedBlockAck();
     }
+    if (const auto gcrGroupAddr = respHdr.GetGcrGroupAddress())
+    {
+        agreement.SetGcrGroupAddress(*gcrGroupAddr);
+    }
+
+    if (auto it = GetRecipientBaAgreement(originator, tid, respHdr.GetGcrGroupAddress());
+        it != m_recipientAgreements.end())
+    {
+        it->second = std::move(agreement);
+    }
+    else
+    {
+        m_recipientAgreements.emplace(std::make_pair(originator, tid), std::move(agreement));
+    }
 
-    m_recipientAgreements.insert_or_assign({originator, tid}, agreement);
+    const auto [first, last] = m_recipientAgreements.equal_range({originator, tid});
+    NS_ASSERT_MSG(
+        std::count_if(first,
+                      last,
+                      [&respHdr](const auto& elem) {
+                          return elem.second.GetGcrGroupAddress() == respHdr.GetGcrGroupAddress();
+                      }) == 1,
+        "There exists more than one " << (respHdr.GetGcrGroupAddress().has_value() ? "GCR " : " ")
+                                      << "Block Ack agreement for originator " << originator
+                                      << " and tid " << +tid);
 }
 
 void
-BlockAckManager::DestroyRecipientAgreement(const Mac48Address& originator, uint8_t tid)
+BlockAckManager::DestroyRecipientAgreement(const Mac48Address& originator,
+                                           uint8_t tid,
+                                           std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << originator << tid);
-
-    if (auto agreementIt = m_recipientAgreements.find({originator, tid});
-        agreementIt != m_recipientAgreements.end())
+    NS_LOG_FUNCTION(this << originator << tid << gcrGroupAddr.has_value());
+    if (auto it = GetRecipientBaAgreement(originator, tid, gcrGroupAddr);
+        it != m_recipientAgreements.end())
     {
         // forward up the buffered MPDUs before destroying the agreement
-        agreementIt->second.Flush();
-        m_recipientAgreements.erase(agreementIt);
+        it->second.Flush();
+        m_recipientAgreements.erase(it);
     }
 }
 
@@ -228,15 +369,32 @@
 BlockAckManager::StorePacket(Ptr<WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
-    NS_ASSERT(mpdu->GetHeader().IsQosData());
+    DoStorePacket(mpdu, mpdu->GetHeader().GetAddr1());
+}
 
-    uint8_t tid = mpdu->GetHeader().GetQosTid();
-    Mac48Address recipient = mpdu->GetHeader().GetAddr1();
+void
+BlockAckManager::StoreGcrPacket(Ptr<WifiMpdu> mpdu, const GcrManager::GcrMembers& members)
+{
+    NS_LOG_FUNCTION(this << *mpdu << members.size());
+    for (const auto& member : members)
+    {
+        DoStorePacket(mpdu, member, mpdu->begin()->second.GetDestinationAddr());
+    }
+}
 
-    auto agreementIt = m_originatorAgreements.find({recipient, tid});
+void
+BlockAckManager::DoStorePacket(Ptr<WifiMpdu> mpdu,
+                               const Mac48Address& recipient,
+                               std::optional<Mac48Address> gcrGroupAddr)
+{
+    NS_LOG_FUNCTION(this << *mpdu << recipient << gcrGroupAddr.has_value());
+    NS_ASSERT(mpdu->GetHeader().IsQosData());
+
+    const auto tid = mpdu->GetHeader().GetQosTid();
+    auto agreementIt = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
     NS_ASSERT(agreementIt != m_originatorAgreements.end());
 
-    uint16_t mpduDist =
+    const auto mpduDist =
         agreementIt->second.first.GetDistance(mpdu->GetHeader().GetSequenceNumber());
 
     if (mpduDist >= SEQNO_SPACE_HALF_SIZE)
@@ -256,7 +414,7 @@
             return;
         }
 
-        uint16_t dist =
+        const auto dist =
             agreementIt->second.first.GetDistance((*it)->GetHeader().GetSequenceNumber());
 
         if (mpduDist > dist || (mpduDist == dist && mpdu->GetHeader().GetFragmentNumber() >
@@ -274,19 +432,14 @@
 uint32_t
 BlockAckManager::GetNBufferedPackets(const Mac48Address& recipient, uint8_t tid) const
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    auto it = m_originatorAgreements.find({recipient, tid});
-    if (it == m_originatorAgreements.end())
-    {
-        return 0;
-    }
-    return it->second.second.size();
+    const auto it = GetOriginatorBaAgreement(recipient, tid);
+    return (it != m_originatorAgreements.cend()) ? it->second.second.size() : 0;
 }
 
 void
 BlockAckManager::SetBlockAckThreshold(uint8_t nPackets)
 {
-    NS_LOG_FUNCTION(this << +nPackets);
+    NS_LOG_FUNCTION(this << nPackets);
     m_blockAckThreshold = nPackets;
 }
 
@@ -297,7 +450,7 @@
                                     const OriginatorAgreementsI& it,
                                     const Time& now)
 {
-    NS_LOG_FUNCTION(this << linkId << **mpduIt << +static_cast<uint8_t>(status));
+    NS_LOG_FUNCTION(this << linkId << **mpduIt << static_cast<uint8_t>(status));
 
     if (!(*mpduIt)->IsQueued())
     {
@@ -315,7 +468,7 @@
 
     const WifiMacHeader& hdr = (*mpduIt)->GetHeader();
 
-    NS_ASSERT(hdr.GetAddr1() == it->first.first);
+    NS_ASSERT((hdr.GetAddr1() == it->first.first) || hdr.GetAddr1().IsGroup());
     NS_ASSERT(hdr.IsQosData() && hdr.GetQosTid() == it->first.second);
 
     if (it->second.first.GetDistance(hdr.GetSequenceNumber()) >= SEQNO_SPACE_HALF_SIZE)
@@ -361,14 +514,18 @@
     NS_LOG_FUNCTION(this << linkId << *mpdu);
     NS_ASSERT(mpdu->GetHeader().IsQosData());
 
-    Mac48Address recipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
-    uint8_t tid = mpdu->GetHeader().GetQosTid();
+    const auto recipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
+    const auto tid = mpdu->GetHeader().GetQosTid();
 
-    auto it = m_originatorAgreements.find({recipient, tid});
+    auto it = GetOriginatorBaAgreement(recipient, tid);
     NS_ASSERT(it != m_originatorAgreements.end());
     NS_ASSERT(it->second.first.IsEstablished());
 
     it->second.first.NotifyAckedMpdu(mpdu);
+    if (!m_txOkCallback.IsNull())
+    {
+        m_txOkCallback(mpdu);
+    }
 
     // remove the acknowledged frame from the queue of outstanding packets
     for (auto queueIt = it->second.second.begin(); queueIt != it->second.second.end(); ++queueIt)
@@ -383,15 +540,32 @@
 }
 
 void
+BlockAckManager::NotifyLastGcrUrTx(Ptr<const WifiMpdu> mpdu,
+                                   const GcrManager::GcrMembers& recipients)
+{
+    NS_LOG_FUNCTION(this << *mpdu << recipients.size());
+    NS_ASSERT(mpdu->GetHeader().IsQosData());
+    const auto tid = mpdu->GetHeader().GetQosTid();
+    const auto gcrGroupAddr = mpdu->GetHeader().GetAddr1();
+    for (const auto& recipient : recipients)
+    {
+        auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
+        NS_ASSERT(it != m_originatorAgreements.end());
+        NS_ASSERT(it->second.first.IsEstablished());
+        it->second.first.NotifyAckedMpdu(mpdu);
+    }
+}
+
+void
 BlockAckManager::NotifyMissedAck(uint8_t linkId, Ptr<WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << linkId << *mpdu);
     NS_ASSERT(mpdu->GetHeader().IsQosData());
 
-    Mac48Address recipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
-    uint8_t tid = mpdu->GetHeader().GetQosTid();
+    const auto recipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
+    const auto tid = mpdu->GetHeader().GetQosTid();
 
-    auto it = m_originatorAgreements.find({recipient, tid});
+    auto it = GetOriginatorBaAgreement(recipient, tid);
     NS_ASSERT(it != m_originatorAgreements.end());
     NS_ASSERT(it->second.first.IsEstablished());
 
@@ -428,7 +602,7 @@
         tid = *tids.begin();
     }
 
-    auto it = m_originatorAgreements.find({recipient, tid});
+    auto it = GetOriginatorBaAgreement(recipient, tid);
     if (it == m_originatorAgreements.end() || !it->second.first.IsEstablished())
     {
         return {0, 0};
@@ -445,7 +619,12 @@
         it->second.first.m_inactivityEvent.Cancel();
         Time timeout = MicroSeconds(1024 * it->second.first.GetTimeout());
         it->second.first.m_inactivityEvent =
-            Simulator::Schedule(timeout, &BlockAckManager::InactivityTimeout, this, recipient, tid);
+            Simulator::Schedule(timeout,
+                                &BlockAckManager::InactivityTimeout,
+                                this,
+                                recipient,
+                                tid,
+                                std::nullopt);
     }
 
     NS_ASSERT(blockAck.IsCompressed() || blockAck.IsExtendedCompressed() || blockAck.IsMultiSta());
@@ -500,18 +679,152 @@
     return {nSuccessfulMpdus, nFailedMpdus};
 }
 
+std::optional<std::pair<uint16_t, uint16_t>>
+BlockAckManager::NotifyGotGcrBlockAck(uint8_t linkId,
+                                      const CtrlBAckResponseHeader& blockAck,
+                                      const Mac48Address& recipient,
+                                      const GcrManager::GcrMembers& members)
+{
+    NS_LOG_FUNCTION(this << linkId << blockAck << recipient);
+    NS_ABORT_MSG_IF(!blockAck.IsGcr(), "GCR Block Ack is expected");
+    NS_ABORT_MSG_IF(members.count(recipient) == 0,
+                    "Received GCR Block Ack response from unexpected recipient");
+
+    const auto tid = blockAck.GetTidInfo();
+    auto it = GetOriginatorBaAgreement(recipient, tid, blockAck.GetGcrGroupAddress());
+    if (it == m_originatorAgreements.end() || !it->second.first.IsEstablished())
+    {
+        return {};
+    }
+
+    NS_ASSERT_MSG(it->second.first.GetGcrGroupAddress().has_value() &&
+                      it->second.first.GetGcrGroupAddress().value() ==
+                          blockAck.GetGcrGroupAddress(),
+                  "No GCR agreement for group address " << blockAck.GetGcrGroupAddress());
+    if (it->second.first.m_inactivityEvent.IsPending())
+    {
+        /* Upon reception of a BlockAck frame, the inactivity timer at the
+            originator must be reset.
+            For more details see section 11.5.3 in IEEE802.11e standard */
+        it->second.first.m_inactivityEvent.Cancel();
+        Time timeout = MicroSeconds(1024 * it->second.first.GetTimeout());
+        it->second.first.m_inactivityEvent =
+            Simulator::Schedule(timeout,
+                                &BlockAckManager::InactivityTimeout,
+                                this,
+                                recipient,
+                                tid,
+                                blockAck.GetGcrGroupAddress());
+    }
+
+    auto itGcrBlockAcks = m_gcrBlockAcks.find(blockAck.GetGcrGroupAddress());
+    NS_ASSERT(itGcrBlockAcks != m_gcrBlockAcks.end());
+    NS_ASSERT(itGcrBlockAcks->second.count(recipient) == 0);
+    itGcrBlockAcks->second[recipient] = blockAck;
+
+    if (itGcrBlockAcks->second.size() < members.size())
+    {
+        // we need to collect feedback from all members
+        NS_LOG_DEBUG("Expecting more GCR Block ACK(s)");
+        return {};
+    }
+
+    std::vector<bool> acked;
+    for (auto queueIt = it->second.second.begin(); queueIt != it->second.second.end(); ++queueIt)
+    {
+        auto currentSeq = (*queueIt)->GetHeader().GetSequenceNumber();
+        NS_LOG_DEBUG("Current seq=" << currentSeq);
+        auto received = true;
+        for ([[maybe_unused]] const auto& [recipient, gcrBlockAcks] : itGcrBlockAcks->second)
+        {
+            received &= gcrBlockAcks.IsPacketReceived(currentSeq, 0);
+        }
+        acked.emplace_back(received);
+    }
+
+    uint16_t nSuccessfulMpdus = 0;
+    uint16_t nFailedMpdus = 0;
+    const auto now = Simulator::Now();
+    std::list<Ptr<const WifiMpdu>> ackedMpdus;
+    auto countAndNotify = true;
+    for (const auto& member : members)
+    {
+        std::size_t index = 0;
+        it = GetOriginatorBaAgreement(member, tid, blockAck.GetGcrGroupAddress());
+        NS_ASSERT(acked.size() == it->second.second.size());
+        for (auto queueIt = it->second.second.begin(); queueIt != it->second.second.end();)
+        {
+            if (acked.at(index++))
+            {
+                it->second.first.NotifyAckedMpdu(*queueIt);
+                if (countAndNotify)
+                {
+                    nSuccessfulMpdus++;
+                    if (!m_txOkCallback.IsNull())
+                    {
+                        m_txOkCallback(*queueIt);
+                    }
+                    ackedMpdus.emplace_back(*queueIt);
+                }
+                queueIt = HandleInFlightMpdu(linkId, queueIt, ACKNOWLEDGED, it, now);
+            }
+            else
+            {
+                ++queueIt;
+            }
+        }
+        countAndNotify = false;
+    }
+
+    // Dequeue all acknowledged MPDUs at once
+    m_queue->DequeueIfQueued(ackedMpdus);
+
+    // Remaining outstanding MPDUs have not been acknowledged
+    countAndNotify = true;
+    for (const auto& member : members)
+    {
+        it = GetOriginatorBaAgreement(member, tid, blockAck.GetGcrGroupAddress());
+        for (auto queueIt = it->second.second.begin(); queueIt != it->second.second.end();)
+        {
+            // transmission actually failed if the MPDU is inflight only on the same link on
+            // which we received the BlockAck frame
+            auto linkIds = (*queueIt)->GetInFlightLinkIds();
+
+            if (linkIds.size() == 1 && *linkIds.begin() == linkId)
+            {
+                if (countAndNotify)
+                {
+                    nFailedMpdus++;
+                    if (!m_txFailedCallback.IsNull())
+                    {
+                        m_txFailedCallback(*queueIt);
+                    }
+                }
+                queueIt = HandleInFlightMpdu(linkId, queueIt, TO_RETRANSMIT, it, now);
+                continue;
+            }
+
+            queueIt = HandleInFlightMpdu(linkId, queueIt, STAY_INFLIGHT, it, now);
+        }
+        countAndNotify = false;
+    }
+
+    itGcrBlockAcks->second.clear();
+    return std::make_pair(nSuccessfulMpdus, nFailedMpdus);
+}
+
 void
 BlockAckManager::NotifyMissedBlockAck(uint8_t linkId, const Mac48Address& recipient, uint8_t tid)
 {
-    NS_LOG_FUNCTION(this << linkId << recipient << +tid);
+    NS_LOG_FUNCTION(this << linkId << recipient << tid);
 
-    auto it = m_originatorAgreements.find({recipient, tid});
+    auto it = GetOriginatorBaAgreement(recipient, tid);
     if (it == m_originatorAgreements.end() || !it->second.first.IsEstablished())
     {
         return;
     }
 
-    Time now = Simulator::Now();
+    const auto now = Simulator::Now();
 
     // remove all packets from the queue of outstanding packets (they will be
     // re-inserted if retransmitted)
@@ -532,7 +845,6 @@
 BlockAckManager::NotifyDiscardedMpdu(Ptr<const WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
-
     if (!mpdu->GetHeader().IsQosData())
     {
         NS_LOG_DEBUG("Not a QoS Data frame");
@@ -545,30 +857,53 @@
         return;
     }
 
-    Mac48Address recipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
-    uint8_t tid = mpdu->GetHeader().GetQosTid();
-    auto it = m_originatorAgreements.find({recipient, tid});
-    if (it == m_originatorAgreements.end() || !it->second.first.IsEstablished())
+    const auto recipient = mpdu->GetOriginal()->GetHeader().GetAddr1();
+    const auto tid = mpdu->GetHeader().GetQosTid();
+    if (!recipient.IsGroup())
+    {
+        auto it = GetOriginatorBaAgreement(recipient, tid);
+        HandleDiscardedMpdu(mpdu, it);
+    }
+    else
+    {
+        const auto groupAddress = mpdu->GetOriginal()->GetHeader().GetAddr1();
+        for (auto it = m_originatorAgreements.begin(); it != m_originatorAgreements.end(); ++it)
+        {
+            if (it->first.second != tid || !it->second.first.GetGcrGroupAddress().has_value() ||
+                it->second.first.GetGcrGroupAddress().value() != groupAddress)
+            {
+                continue;
+            }
+            HandleDiscardedMpdu(mpdu, it);
+        }
+    }
+}
+
+void
+BlockAckManager::HandleDiscardedMpdu(Ptr<const WifiMpdu> mpdu, OriginatorAgreementsI iter)
+{
+    if (iter == m_originatorAgreements.end() || !iter->second.first.IsEstablished())
     {
         NS_LOG_DEBUG("No established Block Ack agreement");
         return;
     }
 
-    uint16_t currStartingSeq = it->second.first.GetStartingSequence();
-    if (QosUtilsIsOldPacket(currStartingSeq, mpdu->GetHeader().GetSequenceNumber()))
+    auto& [baAgreement, packetQueue] = iter->second;
+    if (const auto currStartingSeq = baAgreement.GetStartingSequence();
+        QosUtilsIsOldPacket(currStartingSeq, mpdu->GetHeader().GetSequenceNumber()))
     {
         NS_LOG_DEBUG("Discarded an old frame");
         return;
     }
 
     // actually advance the transmit window
-    it->second.first.NotifyDiscardedMpdu(mpdu);
+    baAgreement.NotifyDiscardedMpdu(mpdu);
 
     // remove old MPDUs from the EDCA queue and from the in flight queue
     // (including the given MPDU which became old after advancing the transmit window)
-    for (auto mpduIt = it->second.second.begin(); mpduIt != it->second.second.end();)
+    for (auto mpduIt = iter->second.second.begin(); mpduIt != iter->second.second.end();)
     {
-        if (it->second.first.GetDistance((*mpduIt)->GetHeader().GetSequenceNumber()) >=
+        if (baAgreement.GetDistance((*mpduIt)->GetHeader().GetSequenceNumber()) >=
             SEQNO_SPACE_HALF_SIZE)
         {
             NS_LOG_DEBUG("Dropping old MPDU: " << **mpduIt);
@@ -577,7 +912,7 @@
             {
                 m_droppedOldMpduCallback(*mpduIt);
             }
-            mpduIt = it->second.second.erase(mpduIt);
+            mpduIt = packetQueue.erase(mpduIt);
         }
         else
         {
@@ -586,6 +921,7 @@
     }
 
     // schedule a BlockAckRequest
+    const auto [recipient, tid] = iter->first;
     NS_LOG_DEBUG("Schedule a Block Ack Request for agreement (" << recipient << ", " << +tid
                                                                 << ")");
 
@@ -598,48 +934,60 @@
     hdr.SetNoRetry();
     hdr.SetNoMoreFragments();
 
-    ScheduleBar(GetBlockAckReqHeader(recipient, tid), hdr);
+    ScheduleBar(GetBlockAckReqHeader(recipient, tid, baAgreement.GetGcrGroupAddress()), hdr);
 }
 
 void
 BlockAckManager::NotifyGotBlockAckRequest(const Mac48Address& originator,
                                           uint8_t tid,
-                                          uint16_t startingSeq)
+                                          uint16_t startingSeq,
+                                          std::optional<Mac48Address> gcrGroupAddr)
 {
-    NS_LOG_FUNCTION(this << originator << tid << startingSeq);
-    auto it = m_recipientAgreements.find({originator, tid});
-    if (it == m_recipientAgreements.end())
+    NS_LOG_FUNCTION(this << originator << tid << startingSeq << gcrGroupAddr.has_value());
+    if (auto it = GetRecipientBaAgreement(originator, tid, gcrGroupAddr);
+        it != m_recipientAgreements.end())
     {
-        return;
+        it->second.NotifyReceivedBar(startingSeq);
     }
-    it->second.NotifyReceivedBar(startingSeq);
 }
 
 void
 BlockAckManager::NotifyGotMpdu(Ptr<const WifiMpdu> mpdu)
 {
     NS_LOG_FUNCTION(this << *mpdu);
-    auto originator = mpdu->GetOriginal()->GetHeader().GetAddr2();
     NS_ASSERT(mpdu->GetHeader().IsQosData());
-    auto tid = mpdu->GetHeader().GetQosTid();
-
-    auto it = m_recipientAgreements.find({originator, tid});
-    if (it == m_recipientAgreements.end())
+    const auto originator = mpdu->GetOriginal()->GetHeader().GetAddr2();
+    const auto tid = mpdu->GetHeader().GetQosTid();
+    std::optional<Mac48Address> groupAddress;
+    if (const auto addr1 = mpdu->GetOriginal()->GetHeader().GetAddr1(); addr1.IsGroup())
     {
-        return;
+        groupAddress =
+            mpdu->GetHeader().IsQosAmsdu() ? mpdu->begin()->second.GetDestinationAddr() : addr1;
+    }
+    if (auto it = GetRecipientBaAgreement(originator, tid, groupAddress);
+        it != m_recipientAgreements.end())
+    {
+        it->second.NotifyReceivedMpdu(mpdu);
     }
-    it->second.NotifyReceivedMpdu(mpdu);
 }
 
 CtrlBAckRequestHeader
-BlockAckManager::GetBlockAckReqHeader(const Mac48Address& recipient, uint8_t tid) const
+BlockAckManager::GetBlockAckReqHeader(const Mac48Address& recipient,
+                                      uint8_t tid,
+                                      std::optional<Mac48Address> gcrGroupAddr) const
 {
-    NS_LOG_FUNCTION(this << recipient << +tid);
-    auto it = m_originatorAgreements.find({recipient, tid});
+    auto it = GetOriginatorBaAgreement(recipient, tid, gcrGroupAddr);
     NS_ASSERT(it != m_originatorAgreements.end());
-
     CtrlBAckRequestHeader reqHdr;
-    reqHdr.SetType((*it).second.first.GetBlockAckReqType());
+    if (gcrGroupAddr.has_value())
+    {
+        reqHdr.SetType(BlockAckReqType::GCR);
+        reqHdr.SetGcrGroupAddress(gcrGroupAddr.value());
+    }
+    else
+    {
+        reqHdr.SetType((*it).second.first.GetBlockAckReqType());
+    }
     reqHdr.SetTidInfo(tid);
     reqHdr.SetStartingSequence((*it).second.first.GetStartingSequence());
     return reqHdr;
